<template>
  <section
    id="category-slug"
    class="animate__animated animate__fadeIn animate__faster"
  >
    <!-- <MainBanner /> -->

    <LocalLoader v-if="loading" />

    <section id="products-container">
      <!-- Productos por categoría -->
      <ProductsList
        :title="$route.query.q"
        :products="products"
        :filters="true"
        :loading="loading"
      />

      <!-- Productos destacados por si la búsqueda no cuenta con productos -->
      <div class="mt-3">
        <ProductsList
          title="Productos destacados"
          :products="featuredProducts"
          :filters="false"
          :loading="loadingFeaturesProducts"
          v-if="!products.length"
        />
      </div>
    </section>

    <div class="d-flex justify-content-center mt-5">
      <b-pagination
        v-model="page"
        :total-rows="nroItems"
        :per-page="number_paginate"
        @change="paginate($event)"
        v-if="products.length && nroItems > number_paginate"
      ></b-pagination>
    </div>
  </section>
</template>

<script>
import GetProductosRelacionados from "@/graphql/queries/productos/GetProductosRelacionados.gql";
import GetProductos from "@/graphql/queries/productos/GetProductos.gql";

import ProductsList from "@/components/products/ProductsList";
import LocalLoader from "@/components/global/loaders/LocalLoader";

export default {
  data() {
    return {
      query: this.$route.query.q,
      number_paginate: 12,
      page: 1,
      products: [],
      featuredProducts: [],
      loading: false,
      loadingFeaturesProducts: false,
      filterStatus: false
    };
  },
  async created() {
    if (this.$route.query.p) {
      this.page = this.$route.query.p;
    }

    this.products = await this.getProducts();

    console.log(this.products)

    if (!this.products.length) {
      this.featuredProducts = await this.getFeaturedProducts();
    }

    this.$store.commit("SET_LOADER", false);
  },
  watch: {
    "$route.query.q": async function (val) {
      this.query = val;
      this.products = await this.getProducts();
    },
  },
  components: {
    ProductsList,
    LocalLoader,
  },
  methods: {
    async getProducts() {
      try {
        this.loading = true;

        let palabraClave = this.query,
          number_paginate = this.number_paginate,
          page = this.page;

        let response = await this.$apollo.query({
          query: GetProductosRelacionados,
          variables: {
            number_paginate,
            page,
            palabraClave,
          },
          fetchPolicy: "no-cache",
        });

        this.nroItems = response.data.GetProductosRelacionados.NroItems;

        this.loading = false;

        return response.data.GetProductosRelacionados.data;
      } catch (error) {
        this.$store.commit("SET_LOADER", false);
      }
    },
    async getFeaturedProducts() {
      this.loadingFeaturesProducts = true;

      let response = await this.$apollo.query({
        query: GetProductos,
        variables: {
          number_paginate: this.number_paginate,
          page: this.page,
          estado: "1", // Visibles = 1, ocultos = 0
        },
        fetchPolicy: "no-cache",
      });

      this.loadingFeaturesProducts = false;

      return response.data.GetProductos.data;
    },
    async paginate(event) {
      this.page = event;

      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: {
          ...this.$route.query,
          p: event
        },
      });

      if (this.filterStatus) {
        this.products = await this.getProductsByFilter();
      } else {
        this.products = await this.getProducts();
      }

      const myEl = document.getElementById("products-container");

      this.$smoothScroll({
        scrollTo: myEl,
        updateHistory: false,
      });
    }
  },
};
</script>

<style></style>
